module Pastebinner
  class OptionParser
    def self.parse!(argv = ARGV)
      options = {}
      OptParse.new do |opts|
        opts.default_argv = argv

        opts.banner = 'Usage: pastebinner [options]'

        opts.on('-h', '--help', 'Show this help messae') do
          puts opts
          exit
        end
      
        opts.on('-v', '--verbose', 'Verbose http output (WIP)') do |_v|
          options[:v] = true
        end

        opts.on('-s', '--scrape_public', 'Scrape public pastes') do |_s|
          options[:s] = true
        end

        opts.on('-r', '--raw', 'Raw paste. Requires --key passed with a valid key') do |_r|
          options[:r] = true
        end

        opts.on('-g', '--get_keys', 'Get unique paste keys from public pastes') do |_g|
          options[:g] = true
        end

        opts.on('-k', '--key=', 'Unique paste key') do |k|
          options[:k] = k
        end

        opts.on('-d', '--download', 'Download all public pastes to data directory') do |_d|
          options[:d] = true
        end

        opts.on('-j', '--json', 'Download all public pastes as a json into data directory') do |_j|
          options[:j] = true
        end

        opts.on('-t', '--trending', 'Trending pastes') do |_t|
          options[:t] = true
        end
        opts.parse!
      end
      options
    end
  end
end
